#!/usr/bin/env python
# -*- coding: utf8 -*-
'''

Parrot:  The classifier that always says the same thing.  This is useful when
other learners/predictors (looking at WEKA) do not support the degenerate case.

Copyright © 210 Keith Noto.  Disributed under Gnu General Public License (see http://www.gnu.org/licenses/gpl.html).

'''
__author__ = "Keith Noto <noto@cs.tufts.edu>";
__license__ = "GPL";
__copyright__ = "Copyright © 2009 Keith Noto";
VERSION = __revision__ = "1.0";

# The LAST feature is the class feature
class Learner:
	def __init__(self, value):
		self.value = value;
	def __call__(self,trainset):
		return Predictor(self.value);

class Predictor:
	def __init__(self,value):
		self.value = value;
	def __call__(self,x):
		return self.value;
	def predictions(self, X): # Must maintain order of 'X'
		for x in X:
			yield self.value;
