#!/usr/bin/env bash

D=$1
if [ "$D" == "" ]; then echo "Usage: $0 <results directory>">&2; exit; fi;

cd $D
for file in labels lof frac.surprisal frac.normalized-surprisal frac.constrained frac.voting frac.error 
do
	if [ ! -e $file ]
	then
		echo "# `basename $D` missing $file" >&2;
		exit
	fi;
done

echo -ne "#\tClass\tAnomaly?\tLOF\tSurprisal\tNorm.Surprisal\tConstrained.Surprisal\tVoting\tError\n";

for LAB in `cat labels | gawk '{print $1}' | sort | uniq`; 
do 
	paste labels lof frac.surprisal frac.normalized-surprisal frac.constrained frac.voting frac.error | grep "^${LAB}" | cat -n
	
	echo -ne "#\t${LAB}\t"; 

	paste labels lof frac.surprisal frac.normalized-surprisal frac.constrained frac.voting frac.error \
		| grep "^${LAB}" \
		| gawk '{print $2"\t"$3"\t"$4"\t"$5"\t"$6"\t"$7"\t"$8"\t"$9}'  \
		| ag --mean

done

echo -ne "\n# (Averages)\n\n#\tClass\tAnomaly?\tLOF\tSurprisal\tNorm.Surprisal\tConstrained.Surprisal\tVoting\tError\n";

for LAB in `cat labels | gawk '{print $1}' | sort | uniq`; 
do 
	
	echo -ne "#\t${LAB}\t"; 

	paste labels lof frac.surprisal frac.normalized-surprisal frac.constrained frac.voting frac.error \
		| grep "^${LAB}" \
		| gawk '{print $2"\t"$3"\t"$4"\t"$5"\t"$6"\t"$7"\t"$8}'  \
		| ag --mean \
		| gawk '{printf("%i\t%2.2f\t%2.2f\t%2.2f\t%2.2f\t%2.2f\t%2.2f\n", $1,$2,$3,$4,$5,$6,$7);}'

done
