#!/bin/bash

# Data set, examples, features = 1,2,3
OCSVM=7
LOF=9
EUB=4
FRAC_RBF=12
FRAC_LINEAR=13
FRAC_TREE=14
FRAC=23

echo -ne "\\\\begin{tabular}{|    r    |  r  |  r  ||  r  ||  r  |  r  |  r  |}\n";
echo -ne "\\\\hline\n";
echo -ne "         &          &          & Estimated   & One-Class &       &       \\\\\\\\\n";
echo -ne "Data Set & Examples & Features & Upper-Bound & SVMs      & \lof  & \FRaC \\\\\\\\\n";
echo -ne "\\\\hline\n";
cat $1 | sed 's/_/\\_/g' | lines 2- | gawk -F '	' '{printf("%s%s\t%s\t%s\t%s\t%s\t%s\t%s\n", (($2<100)?"%":""), $1, $2, $3, $'$EUB', $'$OCSVM', $'$LOF', $'$FRAC');}' | gawk -F '	' 'function max(a,b) { ans=$a; for (i=a+1; i<=b; i++) { ans = $i > ans ? $i : ans; } return ans; } { x=max(5,7); printf("%30s & \t%6i & \t%6i & \t%.2f & \t{%s%.2f} & \t{%s%.2f} & \t{%s%.2f} \\\\ %% max=%s\n", $1,$2,$3,$4, ($5==x)?"\\bf ":"", $5, ($6==x)?"\\bf ":"", $6, ($7==x)?"\\bf ":"", $7, x); }'

#echo -ne "\\\\begin{tabular}{|    r    |  r  |  r  |  r  |  r  |}\n";
#echo -ne "\\\\hline\n";
#echo -ne "         & RBF & Linear & Decision &            \\\\\\\\ \n";
#echo -ne "Data Set & SVM & SVM    & Tree     &  Combined  \\\\\\\\ \n";
#echo -ne "\\\\hline\n";
#cat $1 | sed 's/_/\\_/g' | lines 2- | gawk -F '	' '{printf("%s%s\t%s\t%s\t%s\t%s\n", (($2<100)?"%":""), $1, $'$FRAC_RBF', $'$FRAC_LINEAR', $'$FRAC_TREE', $'$FRAC');}' | gawk -F '	' 'function max(a,b) { ans=$a; for (i=a+1; i<=b; i++) { ans = $i > ans ? $i : ans; } return ans; } { x=max(2,5); printf("%30s & \t{%s%.2f} & \t{%s%.2f} & \t{%s%.2f} & \t{%s%.2f} \\\\ %% max=%s \n", $1, ($2==x)?"\\bf ":"", $2, ($3==x)?"\\bf ":"", $3, ($4==x)?"\\bf ":"", $4, ($5==x)?"\\bf ":"", $5, x); }'

echo -ne "\\\\hline\n";
echo -ne "\\\\end{tabular}\n";
