#!/usr/bin/env python
# -*- coding: utf8 -*-
'''
Copyright © 2009 Keith Noto.  Disributed under Gnu General Public License (see http://www.gnu.org/licenses/gpl.html).
'''
__author__ = "Keith Noto <noto@cs.tufts.edu>";
__license__ = "GPL";
__copyright__ = "Copyright © 2009 Keith Noto";
VERSION = __revision__ = "1.0";

import sys,string,math;
from util import *;		

# return arithmetic mean.  Div. by zero, if sequence is empty
def mean(X):
	(sum,N) = reduce(lambda (a,N),x : (a+x,N+1), X, (0.0,0)); 
	return sum / N;

def median(X):
	X = list(X);
	X.sort()
	return X[len(X)/2];
	
# @param bessels_correction Use N-1 in the formula (sample std. dev.) instead of N (population std. dev)
def stdev(X, bessels_correction=False,mu=None):
	mu = mu if mu is not None else mean(X);
	(ssd,N) = reduce(lambda (a,N),x : (a+((mu-x)*(mu-x)) , N+1), X, (0.0,0)); 
	return math.sqrt( ssd / ((N-1) if bessels_correction else N) );

# return the n-norm of vector X
def norm(v, n):
	if n==1:
		return sum(v);
	elif n==1e999:
		return max(v); 
	else:
		return pow( sum(map(lambda c : pow(c,n), v)), 1.0/n );


